
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib


#type = 'PDF'
type = 'PS'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(plt, dim, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, lims):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    plt.subplot(dim)
    bars = []
    for idx, serie in enumerate(series):

        for idx2, height in enumerate(serie):
            if height == 0 :
                serie[idx2] = 18.0

        bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[idx])
        bars.append(bar)
    max_val = x[-1] + len(series) * bwidth

    plt.xticks(x + series_cnt/2. * bwidth, sets_name)
    #plt.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    #plt.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    plt.gca().yaxis.grid(True)
    plt.ylabel(ylabel)
    plt.xlabel(xlabel)

    font = FontProperties(size='small');

    plt.legend(
        [bar[0] for bar in bars], 
        series_name, 
        loc=[1.01, 0.3],
        labelspacing=0.1,
        handlelength=0.7,
        borderaxespad=0.1,
        prop=font).draw_frame(0)

    autolabel(bars[len(bars)-1],bars[0])

    #plt.ylim(ymax = 21)
    plt.ylim(ymax = lims[1])
    plt.xlim(xmax = max_val)
    #plt.ylim(ymin = lims[0])


#color scheme
colors_orig = ['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#######################################################
#data
#######################################################

ws = 0
ms = 1
hs = 0

if ws == 1:
    ylabel = 'System throughput'
    name = 'bar_intensity_ws'
    ylims = [0, 20]

if ms == 1:
    ylabel = 'Maximum slowdown'
    name = 'bar_intensity_ms'
    ylims = [0, 20]

if hs == 1:
    ylabel = 'Harmonic speedup'
    name = 'bar_intensity_hs'
    ylims = [0, 0.8]

#data6 = [
#[17.20, 17.61, 18.05, 18.75, 17.61, 18.07, , 18.50, 18.69, 18.82, 18.94, 19.03],
#[4.631, 3.589, 2.930, 4.923, 3.678, 3.097, , 3.092, 3.084, 3.124, 3.193, 3.313],
#[0.569, 0.638, 0.679, 0.633, 0.645, 0.671, , 0.681, 0.685, 0.686, 0.686, 0.684],
#]

data6 = [
[17.20, 17.61, 18.05, 18.75, 18.82],
[4.631, 3.589, 2.930, 4.923, 3.124],
[0.569, 0.638, 0.679, 0.633, 0.686],
]

data6 = zip(*data6)

#data12 = [
#[12.73, 13.21, 13.61, 14.43, 13.28, 14.04, 14.40, 14.63, 14.79, 14.92],
#[9.825, 6.215, 5.423, 7.458, 5.665, 4.843, 4.952, 5.258, 5.503, 5.727],
#[0.299, 0.373, 0.424, 0.383, 0.416, 0.433, 0.433, 0.427, 0.422, 0.418],
#]

data12 = [
[12.73, 13.21, 13.61, 14.43, 14.63],
[9.825, 6.215, 5.423, 7.458, 5.258],
[0.299, 0.373, 0.424, 0.383, 0.427],
]

data12 = zip(*data12)

#data18 = [
#[8.166, 8.454, 8.898, 9.460, 8.565, 9.614, 9.899, 10.07, 10.16 10.27],
#[14.92, 9.458, 8.137, 12.11, 7.846, 7.723, 7.847, 8.350, 8.537 8.745],
#[0.173, 0.221, 0.266, 0.230, 0.268, 0.268, 0.265, 0.258, 0.254 0.250],
#]
data18 = [
[8.166, 8.454, 8.898, 9.460, 9.614],
[14.92, 9.458, 8.137, 12.11, 7.723],
[0.173, 0.221, 0.266, 0.230, 0.268],
]

data18 = zip(*data18)

#data24 = [
#[5.267, 5.041, 5.087, 4.946, 5.078, 5.496, 5.627, 5.710, 5.721, 5.675],
#[18.26, 12.91, 9.126, 16.35, 8.514, 8.718, 9.153, 10.45, 12.58, 16.54],
#[0.124, 0.150, 0.193, 0.158, 0.193, 0.187, 0.182, 0.172, 0.159, 0.143],
#]

data24 = [
    #[5.267, 5.041, 5.087, 4.946, 5.496],
    #[18.26, 12.91, 9.126, 16.35, 8.718],
    #[0.124, 0.150, 0.193, 0.158, 0.187],
[5.234, 5.044, 5.118, 4.953, 5.496],
[19.45, 13.44, 9.252, 16.96, 8.718],
[0.117, 0.147, 0.194, 0.156, 0.187],
]

data24 = zip(*data24)

data = [data6, data12, data18, data24]
f = [x[0] for x in data]
s = [x[1] for x in data]
p = [x[2] for x in data]
a = [x[3] for x in data]
t = [x[4] for x in data]

if ws == 1:
    idx = 0
if ms == 1:
    idx = 1
if hs == 1:
    idx = 2

f = [x[idx] for x in f[:]]
s = [x[idx] for x in s[:]]
p = [x[idx] for x in p[:]]
a = [x[idx] for x in a[:]]
t = [x[idx] for x in t[:]]

series = [f, s, p, a, t]
#
series_cnt = len(series)
series_name = ['FRFCFS', 'STFM', 'PAR_BS', 'ATLAS', 'TCM']
sets_cnt = len(series[0])
sets_name = ['25%', '50%', '75%', '100%']
xlabel = 'Fraction of memory-intensive benchmarks in a workload'


#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

print 'series'
print series

subplot(plt, 111, width, bwidth, series, x, series_name, sets_name, xlabel,
        ylabel, ylims)

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

plt.subplots_adjust(left=0.10, 
                    right=0.85, 
                    top=0.95,
                    bottom=0.14, 
                    #bottom=0.07, 
                    wspace=0.32)

fig = plt.gcf()
#print fig.get_size_inches()
fig.set_size_inches(8, 3)

if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

