
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib

#type = 'PDF'
type = 'PS'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(fig, dim, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, lims):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    ax = fig.add_subplot(dim)

    bars = []
    for idx, serie in enumerate(series):

        for idx2, height in enumerate(serie):
            if height == 0 :
                serie[idx2] = 18.0

        bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[1])
        #bar = plt.bar(1., serie, bwidth/2, color = colors[1])
        bars.append(bar)
    max_val = x[-1] + len(series) * bwidth

    plt.xticks(x + series_cnt/2. * bwidth, sets_name, fontsize = 16)
    #ax.xticks(x + series_cnt/2. * bwidth, sets_name, fontsize = 'large')
    #ax.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    #ax.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    ax.yaxis.grid(True)
    ax.yaxis.grid(True)
    plt.ylabel(ylabel, fontsize = 16)
    #plt.ylabel(ylabel, rotation = 'horizontal')
    #ax.ylabel(ylabel, fontsize = 'large')
    plt.xlabel(xlabel, fontsize = 16)


    #font = FontProperties(size='small');
    #plt.legend(
    #    [bar[0] for bar in bars], 
    #    series_name, 
    #    loc=[1.01, 0.3],
    #    labelspacing=0.1,
    #    handlelength=0.7,
    #    borderaxespad=0.1,
    #    prop=font).draw_frame(0)

    autolabel(bars[len(bars)-1],bars[0])

    plt.ylim(ymax = 14)
    plt.xlim(xmax = max_val)
    #plt.ylim(ymin = lims[0])


#color scheme
colors_orig = ['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#######################################################
#data
#######################################################


ylabel = 'Slowdown'

name = 'ran_str_ran'
slowdowns = [1.007, 6.65]

#name = 'ran_str_str'
#slowdowns = [11.30, 1.0]

series = []
series = [slowdowns]

series_cnt = len(series)
series_name = ['abc']
sets_cnt = len(series[0])
sets_name = ['random-access', 'streaming']
xlabel = ''


#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

print 'series'
print series


fig = plt.figure()
fig.subplots_adjust(left=0.2, bottom=0.15)
subplot(fig, 111, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, [8, 18])

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

#print fig.get_size_inches()
fig.set_size_inches(4, 2)

if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

