
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib


#type = 'PDF'
type = 'PS'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(plt, dim, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, lims, leg):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    plt.subplot(dim)
    bars = []
    for idx, serie in enumerate(series):

        for idx2, height in enumerate(serie):
            if height == 0 :
                serie[idx2] = 18.0

        bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[idx/4])
        bars.append(bar)
    max_val = x[-1] + len(series) * bwidth

    plt.xticks(x + series_cnt/2. * bwidth, sets_name)
    #plt.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    #plt.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    plt.gca().yaxis.grid(True)
    plt.ylabel(ylabel)
    plt.xlabel(xlabel)

    font = FontProperties(size='small');

    #    [bar[0] for bar in bars], 
    #    series_name, 
    #    loc=[1.01, 0.3],
    #    labelspacing=0.1,
    #    handlelength=0.7,
    #    borderaxespad=0.1,
    #    prop=font).draw_frame(0)

    plt.legend(
        [bars[4*i][0] for i in range(6)],
        leg,
        loc='upper right',
        #loc=[1.01, 0.3],
        labelspacing=0,
        handletextpad=0.15,
        columnspacing=1,
        #labelspacing=0.1,
        handlelength=0.7,
        borderaxespad=0.1,
        prop=font,
        #ncol=series_cnt
        #ncol=2
    ).draw_frame(0)

    autolabel(bars[len(bars)-1],bars[0])

    #plt.ylim(ymax = 21)
    plt.ylim(ymin = lims[0])
    plt.ylim(ymax = lims[1])
    plt.xlim(xmax = max_val)

#color scheme
#colors_orig = 2*['#' + x * 6 for x in '0123456789abcd']
colors_orig = 2*['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#markers
markers = ['^-k', 'D-k', 's-k', 'v-k', 'o-k']

#######################################################
#data
#######################################################

#######################################################
fig = plt.figure()
fig.subplots_adjust(left=0.2, bottom=0.2, right=0.8)
#print fig.get_size_inches()
#######################################################

xlabel = ''
ylabel = 'Speedup'

atlas_basis = [
1.17, 1.17, 1.17, 1.17, 9.25, 4.66, 10.7, 10.6, 5.89, 4.77, 5.34, 7.13, 11.5,
13.1, 8.60, 6.52, 3.28, 3.29, 3.27, 3.27, 13.5, 13.8, 9.37, 8.00
]

tcm_basis = [
1.05, 1.05, 1.05, 1.05, 10.4, 11.4, 11.3, 10.4, 5.77, 6.34, 5.67, 5.97, 7.91,
7.96, 8.33, 9.06, 3.67, 3.89, 3.73, 3.41, 6.97, 6.97, 7.03, 6.78
]

atlas_bad = [
2.37, 2.32, 2.37, 2.36, 12.1, 9.44, 10.3, 12.4, 4.57, 6.11, 5.03, 5.56, 7.03,
5.61, 11.9, 10.9, 3.31, 3.32, 3.06, 3.23, 8.26, 12.1, 5.52, 8.51
]

tcm_bad = [
1.06, 1.05, 1.06, 1.05, 11.0, 11.8, 11.6, 11.0, 5.61, 6.54, 5.72, 5.67, 8.04,
8.68, 9.02, 9.03, 3.46, 3.51, 3.50, 3.67, 6.40, 6.23, 6.54, 6.41
]

atlas_good = [
1.16, 1.16, 1.15, 1.15, 2.86, 3.45, 2.60, 3.73, 5.62, 3.50, 5.53, 4.16, 10.7,
10.7, 9.18, 10.3, 3.80, 3.79, 3.80, 3.80, 33.4, 37.1, 12.5, 37.5
] 

tcm_good = [
1.06, 1.05, 1.05, 1.05, 9.88, 10.3, 10.5, 10.0, 5.66, 5.65, 5.56, 5.71, 7.64,
7.54, 8.68, 6.93, 3.75, 4.54, 3.81, 4.29, 7.93, 7.40, 7.62, 7.39
]

atlas_bad = [100*(y/x-1) for x, y in zip(atlas_basis, atlas_bad)]
atlas_good = [100*(y/x-1) for x, y in zip(atlas_basis, atlas_good)]

tcm_bad = [100*(y/x-1) for x, y in zip(tcm_basis, tcm_bad)]
tcm_good = [100*(y/x-1) for x, y in zip(tcm_basis, tcm_good)]

###########################

#series = [atlas_bad, tcm_bad]
#series = [atlas_good, tcm_good]
#series = zip(*(series[:]))
###########################

atlas = [
4.79, 4.71, 4.79, 4.79, 2.19, 3.08, 3.14, 2.70, 14.6, 7.67, 13.4,
4.71, 7.98, 6.06, 7.60, 15.1, 2.39, 2.34, 2.43, 2.43, 4.29, 5.40,
3.35, 7.03 
]

tcm = [
1.06, 1.06, 1.06, 1.06, 1.41, 1.61, 1.55, 1.60, 6.18, 6.40, 7.49,
7.34, 7.62, 8.47, 8.48, 8.06, 3.24, 3.27, 3.28, 3.47, 4.83, 5.01,
4.93, 4.81
]
leg = [
'gcc: weight-1',
'wrf: weight-2',
'GemsFDTD: weight-4',
'lbm: weight-8',
'libquantum: weight-16',
'mcf: weight-32',
]

ylims = [0, 1]
name = 'results_weight_hetero'
#######################,
atlas = [
3.41, 2.97, 3.90, 3.94, 8.10, 5.26, 7.71, 5.40, 14.2, 14.0,
13.0, 14.2, 24.0, 23.4, 23.5, 24.1, 28.6, 30.9, 30.2, 28.6,
32.6, 33.4, 33.5, 34.6
]

tcm = [
5.96, 5.81, 5.90, 5.93, 7.55, 7.44, 7.37, 7.54, 8.80, 8.88,
9.08, 8.63, 9.24, 10.0, 9.69, 9.89, 11.0, 10.0, 10.2, 10.5,
10.6, 10.5, 10.9, 10.9
]
leg = [
'lbm: weight-1',
'lbm: weight-2',
'lbm: weight-4',
'lbm: weight-8',
'lbm: weight-16',
'lbm: weight-32',
]

ylims = [0, 0.5]
name = 'results_weight'
atlas.reverse()
tcm.reverse()
###########################
series = [atlas, tcm]
series = zip(*(series[:]))


for i, s in enumerate(series[:]):
    series[i] = [1/s[0], 1/s[1]]

series_cnt = len(series)
series_name = range(24)
sets_cnt = len(series[0])
sets_name = ['ATLAS', 'TCM']
#sets_name = ['A', 'B', 'C', 'D', 'AVG']

#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

print 'series'
print series

subplot(plt, 111, width, bwidth, series, x, series_name, sets_name, xlabel,
        ylabel, ylims, leg)

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

fig.set_size_inches(8, 3)
if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

