
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib


#type = 'PDF'
type = 'PS'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(plt, dim, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, lims):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    plt.subplot(dim)
    bars = []
    for idx, serie in enumerate(series):

        for idx2, height in enumerate(serie):
            if height == 0 :
                serie[idx2] = 18.0

        bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[idx])
        bars.append(bar)
    max_val = x[-1] + len(series) * bwidth

    plt.xticks(x + series_cnt/2. * bwidth, sets_name)
    #plt.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    #plt.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    plt.gca().yaxis.grid(True)
    plt.ylabel(ylabel)
    plt.xlabel(xlabel)

    font = FontProperties(size='small');

    plt.legend(
        [bar[0] for bar in bars], 
        series_name, 
        loc=[1.01, 0.3],
        labelspacing=0.1,
        handlelength=0.7,
        borderaxespad=0.1,
        prop=font).draw_frame(0)

    autolabel(bars[len(bars)-1],bars[0])

    #plt.ylim(ymax = 21)
    plt.ylim(ymin = lims[0])
    plt.ylim(ymax = lims[1])
    plt.xlim(xmax = max_val)

#color scheme
colors_orig = ['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#markers
markers = ['^-k', 'D-k', 's-k', 'v-k', 'o-k']

#######################################################
#data
#######################################################

#######################################################
fig = plt.figure()
fig.subplots_adjust(left=0.2, bottom=0.2, right=0.8)
#print fig.get_size_inches()
#######################################################

single = 1
mi = 12
ymetric = 'ws'
ymetric = 'ms'
#ymetric = 'hs'

if single == 1:
    if mi == 12:
        index = [0, 1, 2, 5, 2]

xlabel = 'Workloads'
if ymetric == 'ms':
    ylabel = 'Maximum slowdown'
    if mi == 12:
        ylims = [0, 20]

elif ymetric == 'hs':
    ylabel = 'Harmonic speedup'
    if mi == 12:
        ylims = [0.25, 0.5]
elif ymetric == 'ws':
    ylabel = 'Weighted speedup'
    if mi == 12:
        ylims = [10, 16]

name = 'results_workload_' + ymetric

frfcfs = {}
frfcfs[12] = {}
frfcfs[12]['ws'] = [12.73]
frfcfs[12]['ms'] = [9.825]
frfcfs[12]['hs'] = [0.299]

stfm = {}
stfm[12] = {}
stfm[12]['ws'] = [13.11, 13.21, 13.21, 13.19, 13.16, 13.06]
stfm[12]['ms'] = [5.949, 6.215, 6.423, 6.923, 6.953, 7.263]
stfm[12]['hs'] = [0.378, 0.373, 0.368, 0.359, 0.355, 0.346]

parbs = {}
parbs[12] = {}
parbs[12]['ws'] = [13.60, 13.76, 13.61, 13.68, 13.65, 13.62]
parbs[12]['ms'] = [5.999, 5.449, 5.423, 5.075, 4.905, 4.820]
parbs[12]['hs'] = [0.402, 0.423, 0.424, 0.432, 0.433, 0.433]

atlas = {}
atlas[12] = {}
atlas[12]['ws'] = [14.49, 14.58, 14.80, 14.84, 14.83, 14.43]
atlas[12]['ms'] = [7.018, 7.139, 7.422, 7.501, 7.552, 7.458]
atlas[12]['hs'] = [0.399, 0.397, 0.387, 0.383, 0.384, 0.383]

tcm = {}
tcm[12] = {}
tcm[12]['ws'] = [14.04, 14.40, 14.63, 14.79, 14.92] #13.28,
tcm[12]['ms'] = [4.843, 4.952, 5.258, 5.503, 5.727] #5.665,
tcm[12]['hs'] = [0.433, 0.433, 0.427, 0.422, 0.418] #0.416,

#print frfcfs[mi]['ws']
#print frfcfs[mi][ymetric]
f = zip(frfcfs[mi]['ws'], frfcfs[mi][ymetric])
#print f
s = zip(stfm[mi]['ws'], stfm[mi][ymetric])
p = zip(parbs[mi]['ws'], parbs[mi][ymetric])
a = zip(atlas[mi]['ws'], atlas[mi][ymetric])
t = zip(tcm[mi]['ws'], tcm[mi][ymetric])

series = [f, s, p, a, t]
print f
print s
if single == 1:
    for n, i in enumerate(index):
        series[n] = [series[n][i]]

########per workload results
ws = [
[13.46, 13.51, 13.60, 14.50, 14.47],
[11.09, 11.66, 13.09, 13.95, 14.54],
[12.91, 13.95, 14.63, 14.37, 15.27],
[14.25, 14.31, 14.64, 15.04, 15.30],
]
ws = zip(*(ws[:]))

ms = [
[4.299, 4.559, 5.446, 7.374, 5.607],
[15.74, 9.265, 10.39, 8.844, 3.830],
[23.83, 7.074, 3.475, 5.029, 3.777],
[4.460, 4.512, 3.725, 6.530, 4.079],
]
ms = zip(*(ms[:]))

########
if ymetric == 'ws':
    print 'ws'
    for n in range(len(series)):
        series[n] = list(ws[n]) + [series[n][0][0]]

if ymetric == 'ms':
    print 'ms'
    for n in range(len(series)):
        series[n] = list(ms[n]) + [series[n][0][1]]
#######

series_cnt = len(series)
series_name = ['FRFCFS', 'STFM', 'PAR_BS', 'ATLAS', 'TCM']
sets_cnt = len(series[0])
sets_name = ['A', 'B', 'C', 'D', 'AVG']

#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

print 'series'
print series

subplot(plt, 111, width, bwidth, series, x, series_name, sets_name, xlabel,
        ylabel, ylims)

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

fig.set_size_inches(8, 3)
if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

