
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib
import matplotlib.patches

#type = 'PDF'
type = 'PS'
#type = 'agg'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(plt, dim, width, bwidth, series, x, series_name, sets_name, xlabel,
            ylabel, xlims, ylims):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    ax = fig.add_subplot(dim)

    ###########################################
    lines = []

    series_cnt = len(series)
    for idx, serie in enumerate(series):
        print serie
        x = [i[0] for i in serie]
        y = [i[1] for i in serie]
        line = plt.plot(x, y, markers[idx], markerfacecolor =
                        str(float(series_cnt - idx)/series_cnt)) 
        #line = plt.semilogy(x, y, markers[idx], markerfacecolor =
        #                str(float(series_cnt - idx)/series_cnt)) 
        #, label = series_name[idx])    
        lines.append(line)
    plt.ylabel(ylabel)
    plt.xlabel(xlabel)

    font = FontProperties(size='small');

    print 'yo'
    print lines[0]
    print lines[0][0].__dict__

    #cir = matplotlib.patches.Ellipse([9,2], height = 16, width = 0.7, angle=0.0, fill = True)
    #ax.add_patch(cir)

    plt.legend(
        [line[0] for line in lines],
        series_name, 
        loc=[1.01, 0.5],
        #loc='upper left',
        labelspacing=0.1,
        handlelength=0.6,
        borderaxespad=0.1,
        prop=font).draw_frame(0)

    #ymin, ymax = 2, 12
    #xmin, xmax = 12, 16

    xmin, xmax = xlims
    ymin, ymax = ylims
    plt.ylim(ymin, ymax)
    plt.xlim(xmin, xmax)

    x = range(xmin, xmax + 1, 1)
    x = [8, 8.2, 8.4, 8.6, 8.8, 9]
    #plt.xticks(x, [str(i) for i in x])

    ax.xaxis.grid(True)
    ax.yaxis.grid(True)

    fc = (0.6, 0.6, 0.6)
    plt.text(8.855, 3.3, "---", color=fc, fontsize=35, rotation = -45,
             bbox=dict(boxstyle="rarrow", fc=fc, ec=fc))

    plt.text(8.78, 3.9, "Higher Performance\nand Fairness", ha = 'center',
             color='black', fontsize=10, rotation = 45, fontweight=550)


    #rect = matplotlib.patches.FancyBboxPatch([8.5, 7], height = 0.05, width = 0.05, boxstyle="rarrow", fc=(0.5, 0.5, 0.5))
    #ax.add_patch(rect)

    #plt.text(14.7, 15, '59.2', fontsize = 10)
    #plt.arrow(14.6, 15, 0, 0.5, head_width=0.1)

    ####bar#####################################
    #bars = []
    #for idx, serie in enumerate(series):

    #    #for idx2, height in enumerate(serie):
    #    #    if height == 0 :
    #    #        serie[idx2] = 18.0

    #    bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[idx])
    #    bars.append(bar)
    #max_val = x[-1] + len(series) * bwidth

    #plt.xticks(x + series_cnt/2. * bwidth, sets_name)
    ##plt.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    ##plt.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    #plt.gca().yaxis.grid(True)
    #plt.ylabel(ylabel)
    #plt.xlabel(xlabel)

    #font = FontProperties(size='small');

    #plt.legend(
    #    [bar[0] for bar in bars], 
    #    series_name, 
    #    loc=[1.01, 0.3],
    #    labelspacing=0.1,
    #    handlelength=0.7,
    #    borderaxespad=0.1,
    #    prop=font).draw_frame(0)

    #autolabel(bars[len(bars)-1],bars[0])

    #plt.ylim(ymax = 21)
    #plt.xlim(xmax = max_val)
    ##plt.ylim(ymin = lims[0])
    ############################################



#color scheme
colors_orig = ['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#markers
markers = ['^-k', 'D-k', 's-k', 'v-k']#, o-k']

#######################################################
#data
#######################################################

#######################################################
fig = plt.figure()
fig.subplots_adjust(left=0.2, bottom=0.21, right=0.68)
#print fig.get_size_inches()
#######################################################

ws = [8.166, 8.260, 8.527, 8.778]#, 9.179]
ms = [14.18, 9.245, 7.418, 11.52]#, 7.074]
hs = [0.182, 0.230, 0.280, 0.239]#, 0.278]

series = zip(ws, ms)
print series
s = [ [[s[0], s[1]]] for s in series]


name = 'naive'
xlims = [8, 9]
ylims = [2, 16]

nrr = [13, 7]
#npr = [14.43, 59.15]
npr = [14.43, 15.4]

f = [12.73, 9.825]
p = [13.61, 5.423]
a = [14.43, 7.458]
t = [14.63, 5.258]

series = [[nrr], [npr], [f], [p], [a]] #, [t]]
series = s
print series
series_cnt = len(series)
series_name = ['FRFCFS', 'STFM', 'PAR_BS', 'ATLAS']
sets_cnt = len(series[0])
sets_name = ['50%']

ylabel = 'Maximum slowdown'
xlabel = 'System throughput'
#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

subplot(plt, 111, width, bwidth, series, x, series_name, sets_name, xlabel,
        ylabel, xlims, ylims)

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

#fig.set_size_inches(9, 4)
fig.set_size_inches(9, 4)
if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

