
#!/usr/bin/env python
import os
import sys
import random
import pickle
import re
import matplotlib


#type = 'PDF'
type = 'PS'
matplotlib.use(type)

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.font_manager import fontManager, FontProperties

#subplot
def autolabel(rects, basis):
    # attach some text labels
    for rect in rects:
        height = rect.get_height()
        percent=1
        baseheight = basis[rects.index(rect)].get_height()

        percent= (height-baseheight)/baseheight*100

        #numbers on top of bars
        #plt.text(rect.get_x()+rect.get_width()/2., 0.15 + height, ('%.1f'%(percent))+ "%",
        #        ha='center', va='bottom', fontsize=12)
        #        #ha='center', va='top')

def subplot(plt, dim, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, lims):

    series_cnt = len(series)
    sets_cnt = len(series[0])

    print series_cnt
    print sets_cnt

    plt.subplot(dim)

    ###########################################
    lines = []

    series_cnt = len(series)
    for idx, serie in enumerate(series):
        x = [i[0] for i in serie]
        y = [i[1] for i in serie]
        line = plt.plot(x, y, markers[idx], markerfacecolor =
                        str(float(series_cnt - idx)/series_cnt)) 
        #, label = series_name[idx])    
        lines.append(line)
    plt.ylabel(ylabel)
    plt.xlabel(xlabel)

    font = FontProperties(size='small');

    print 'yo'
    print lines[0]
    print lines[0][0].__dict__

    plt.legend(
        [line[0] for line in lines],
        series_name, 
        #loc=[1.01, 0.3],
        loc='upper right',
        labelspacing=0.1,
        handlelength=0.6,
        borderaxespad=0.1,
        prop=font).draw_frame(0)

    ymin, ymax = 2, 12
    xmin, xmax = 12, 16
    plt.ylim(ymin, ymax)
    plt.xlim(xmin, xmax)

    x = range(xmin, xmax + 1, 1)
    plt.xticks(x, [str(i) for i in x])

    plt.gca().xaxis.grid(True)
    plt.gca().yaxis.grid(True)

    ####bar#####################################
    #bars = []
    #for idx, serie in enumerate(series):

    #    #for idx2, height in enumerate(serie):
    #    #    if height == 0 :
    #    #        serie[idx2] = 18.0

    #    bar = plt.bar(x + idx * bwidth, serie, bwidth, color = colors[idx])
    #    bars.append(bar)
    #max_val = x[-1] + len(series) * bwidth

    #plt.xticks(x + series_cnt/2. * bwidth, sets_name)
    ##plt.xticks(x + series_cnt/2. * bwidth, [str(pow(2,i+1)) for i in range(sets_cnt)])
    ##plt.xticks(x + series_cnt/2. * bwidth, [str(i) for i in range(set_cnt-1)] + ['AVG'])
    #plt.gca().yaxis.grid(True)
    #plt.ylabel(ylabel)
    #plt.xlabel(xlabel)

    #font = FontProperties(size='small');

    #plt.legend(
    #    [bar[0] for bar in bars], 
    #    series_name, 
    #    loc=[1.01, 0.3],
    #    labelspacing=0.1,
    #    handlelength=0.7,
    #    borderaxespad=0.1,
    #    prop=font).draw_frame(0)

    #autolabel(bars[len(bars)-1],bars[0])

    #plt.ylim(ymax = 21)
    #plt.xlim(xmax = max_val)
    ##plt.ylim(ymin = lims[0])
    ############################################



#color scheme
colors_orig = ['#' + x * 6 for x in '0123456789abcd']
len_orig = len(colors_orig)

step = 4
steps = [i + j 
         for i in range(step) 
         for j in range(0, len_orig, step) 
         if i + j < len_orig]
colors = [colors_orig[i] for i in steps]

#markers
markers = ['^-k', 'D-k', 's-k', 'v-k', 'o-k']

#######################################################
#data
#######################################################

xlabel = 'Weighted speedup'
ylabel = 'Maximum slowdown'
name = 'results'

atlas = {}
atlas[12] = {}
atlas[12]['ws'] = [14.49   14.58   14.80   14.84   14.83   14.43]
atlas[12]['ms'] = [7.018   7.139   7.422   7.501   7.552   7.458]
atlas[12]['hs'] = [0.399   0.397   0.387   0.383   0.384   0.383]




#mi24
#frfcfs_ws = [5.585]
#stfm_ws = [5.160, 5.358, 5.465, 5.467, 5.465]
#parbs_ws = [5.141, 5.364, 5.354, 5.522, 5.479, 5.436]
#atlas_ws = [5.402, 5.581, 5.533, 5.511, 5.411, 5.385]
#tcm_ws = [5.020, 5.750, 6.011, 5.929]
#
#frfcfs_ms = [12.94] 
#stfm_ms = [10.37, 10.05, 10.19, 10.20, 10.09] 
#parbs_ms = [10.28, 9.289, 8.511, 8.167, 8.196, 8.239] 
#atlas_ms = [9.612, 9.809, 10.04, 10.09, 10.13, 13.03] 
#tcm_ms = [8.653, 9.424, 14.00, 22.83]

#mi12
#frfcfs_ws = [12.58] 
#stfm_ws = [13.14, 13.28, 13.15, 13.14, 13.15] 
#parbs_ws = [13.60, 13.72, 13.56, 13.57, 13.49, 13.64]
#atlas_ws = [14.34, 14.39, 14.51, 14.51, 14.51, 14.32] 
#tcm_ws = [12.88, 14.08, 14.68, 14.82, 14.91, 14.94]

#frfcfs_ms = [9.557]
#stfm_ms = [5.980, 5.852, 6.784, 6.702, 6.551] 
#parbs_ms = [7.047, 6.546, 5.855, 5.563, 5.269, 4.720] 
#atlas_ms = [7.964, 8.092, 8.280, 8.212, 8.397, 8.739]
#tcm_ms = [6.608, 5.627, 5.501, 6.446, 7.335, 8.387] 

#mi12 - single point
frfcfs_ws = [12.58] 
stfm_ws = [13.28]
parbs_ws = [13.56]
atlas_ws = [14.51]
tcm_ws = [14.82]

frfcfs_ms = [9.557]
stfm_ms = [5.852]
parbs_ms = [5.855]
atlas_ms = [8.397]
tcm_ms = [6.446]

frfcfs = zip(frfcfs_ws, frfcfs_ms)
stfm = zip(stfm_ws, stfm_ms)
parbs = zip(parbs_ws, parbs_ms)
atlas = zip(atlas_ws, atlas_ms)
tcm = zip(tcm_ws, tcm_ms)

series = [frfcfs, stfm, parbs, atlas, tcm]

series_cnt = len(series)
series_name = ['FRFCFS', 'STFM', 'PAR_BS', 'ATLAS', 'TCM']
sets_cnt = len(series[0])
sets_name = ['50%', '75%', '100%']


#######################################################
#graphics
#######################################################
bwidth = 0.2      
width = bwidth * series_cnt * sets_cnt
x = np.linspace(0, width, sets_cnt)

print 'series'
print series

subplot(plt, 111, width, bwidth, series, x, series_name, sets_name, xlabel, ylabel, [8, 18])

#plt.subplots_adjust(left=0.05, 
#                    right=0.93, 
#                    top=0.95,
#                    bottom=0.14, 
#                    #bottom=0.07, 
#                    wspace=0.32)

plt.subplots_adjust(left=0.10, 
                    right=0.85, 
                    top=0.95,
                    bottom=0.14, 
                    #bottom=0.07, 
                    wspace=0.32)

fig = plt.gcf()
#print fig.get_size_inches()
fig.set_size_inches(6, 4)

if type == 'PDF':
    plt.savefig(name)

elif type == 'PS':
    plt.savefig(name)
    cmd = 'ps2eps -B ' + name + '.ps ' + name + '.eps -f'
    print cmd
    os.system(cmd) 
    cmd = "sed -i '/DocumentPaperSizes/d' " + name + '.eps'
    print cmd
    os.system(cmd)
    os.system('rm -rf ' + name + '.ps')

